/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.calculo_fondo;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public abstract class CalculoFondoDAO {
    private static final Logger LOGGER = Logger.getLogger(CalculoFondoDAO.class.getName());

    protected ConnectionHolder connectionHolder;

    public abstract List<CalculoFondo> findAll();

    public abstract List<CalculoFondo> findByCaja(Caja caja);

    public abstract CalculoFondo findById(int id);

    public abstract boolean insertCalculoFondo(CalculoFondo calculoFondo);

    public abstract boolean updateCalculoFondo(CalculoFondo calculoFondo);

    public abstract boolean deleteCalculoFondo(CalculoFondo calculoFondo);

    public abstract int getTotalCalculoFondo(Caja caja);

    protected List<CalculoFondo> cajasFromResultSet(ResultSet rs) throws SQLException {
        List<CalculoFondo> calculoFondoList = new ArrayList<>();
        while (rs.next()) {
            int caja_id = rs.getInt("caja_id");
            Caja caja = new SQLiteCajaDAO().findById(caja_id);
            CalculoFondo calculoFondo = new CalculoFondo();
            calculoFondo.setId(rs.getInt("id"));
            calculoFondo.setValor(rs.getInt("valor"));
            calculoFondo.setDescripcion(rs.getString("descripcion"));
            calculoFondo.setCaja(caja);
            calculoFondoList.add(calculoFondo);

            LOGGER.log(Level.FINER, "Se a creo: {0}", calculoFondo);

        }
        return calculoFondoList;
    }
}
